package geoffhom.com.pKaValues {
	import flash.events.EventDispatcher;
	import flash.system.Security;
	import flash.events.StatusEvent;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.ResultEvent;
	import mx.rpc.http.HTTPService;
	
	/* For e-mailing messages from the user to the developers.
	The actual e-mailing is done by a PHP script.
	*/
	public class Emailer extends EventDispatcher {
		
		public static const EMAIL_SUCCESSFUL:String = "E-mail successful.";
		public static const EMAIL_FAILED:String = "E-mail failed.";
		
		/* Scripts which e-mail the included message.
		*/
		// For testing on our development machine.
		private const EMAIL_SCRIPT_LOCAL:String = DefaultValues.LOCAL_URL + "send-email.php";
		// For running on the server.
		private const EMAIL_SCRIPT_REMOTE:String = DefaultValues.REMOTE_PATH + "send-email.php";
		
		private var _httpService:HTTPService;
		
		public function Emailer() {
		}
		
		/* Load PHP script for e-mailing and give it the message.
		*/
		public function sendMessage(message:Message):void {
			
			_httpService = new HTTPService();
			_httpService.method = "POST";
			
			var scriptURL:String;
			if (Security.sandboxType == Security.LOCAL_TRUSTED)
				scriptURL = EMAIL_SCRIPT_LOCAL;
			else
				scriptURL = EMAIL_SCRIPT_REMOTE;
			_httpService.url = scriptURL;
			
			_httpService.addEventListener(ResultEvent.RESULT, handleHTTPResult, false, 0, true);
			_httpService.addEventListener(FaultEvent.FAULT, handleHTTPFault, false, 0, true);
			_httpService.send(message);
		}
		
		// This should mean the script was found and run.
		private function handleHTTPResult(resultEvent:ResultEvent):void {
			
			resultEvent.currentTarget.removeEventListener(resultEvent.type, arguments.callee);
			resultEvent.currentTarget.removeEventListener(FaultEvent.FAULT, handleHTTPFault);
			
			// Check if the script ran correctly.
			var result:String = String(resultEvent.result);
			//main.logThis("Message sent via e-mail. Result: " + result);
			var code:String;
			// If the script returned a "true," then assume that it worked.
			if (result.search("true") != -1)
				code = Emailer.EMAIL_SUCCESSFUL;
			else
				code = Emailer.EMAIL_FAILED;
			
			// Inform listeners.
			dispatchEvent(new StatusEvent(StatusEvent.STATUS, false, false, code) );
		}
		
		private function handleHTTPFault(faultEvent:FaultEvent):void {
			
			faultEvent.currentTarget.removeEventListener(faultEvent.type, arguments.callee);
			faultEvent.currentTarget.removeEventListener(ResultEvent.RESULT, handleHTTPResult);
			main.logThis("Warning from E-mailer.as: HTTPService.send() faulted.");
		}
	}
}