package geoffhom.com.pKaValues {
	import flash.display.Sprite;
	import flash.events.Event;
	
	import flashx.textLayout.container.ContainerController;
	import flashx.textLayout.conversion.TextConverter;
	import flashx.textLayout.elements.TextFlow;
	import flashx.textLayout.events.StatusChangeEvent;
	
	/* Using the Text Layout Framework to make a simple box of text.
	*/
	public class TLF extends Sprite {
		
		private var _textFlow:TextFlow;
		
		/* Take in an XML formatted for the TLF markup.
		*/
		public function TLF(xml:XML, height:int = 400, hasImage:Boolean = false) {
            
            _textFlow = TextConverter.importToFlow(
            	xml, TextConverter.TEXT_LAYOUT_FORMAT);
            _textFlow.fontFamily = DefaultValues.FONT_FAMILY_TLF;
            _textFlow.fontSize = DefaultValues.FONT_SIZE_TLF;
            
            // If the TLF has an in-line graphic, we need to listen for when it has loaded.
            if (hasImage)
            	_textFlow.addEventListener(StatusChangeEvent.INLINE_GRAPHIC_STATUS_CHANGE,
            		handleGraphicStatusChange);
            
            var width:int = 500;
            _textFlow.flowComposer.addController(new ContainerController(this, width, height) );
            _textFlow.flowComposer.updateAllControllers(); 
		}
		
		// After the graphic has loaded (or failed to load), update the display.        
	    public function handleGraphicStatusChange(event:Event):void {
	    	
	    	_textFlow.flowComposer.updateAllControllers();
	    }   
	}
}