package geoffhom.com.pKaValues {
	import flash.system.Security;

	/* Explanation for what pKa values are.
	This is a TextFlow because the text contains subscript and superscript.
	*/
	public final class WhatArePKaValuesTLF {
		
		// For testing on our development machine.
		private static const LOCAL_PATH:String = "../";
		
		// For running on the server.
		private static const REMOTE_PATH:String = "";
		
		// XML used to make this TLF.
		public static function getXML():XML {
			
			var path:String;
			if (Security.sandboxType == Security.LOCAL_TRUSTED)
				path = LOCAL_PATH;
			else
				path = REMOTE_PATH;
			var formulaImagePath:String = path + "Ka_92_x_43.png";
				
			// To do: move the entire XML to an external XML file?
			XML.ignoreWhitespace = false;
			
			var kXML:XML = <span fontStyle="italic">K</span>;
           	var subAXML:XML = <span format="sub">a</span>;
        
            var xml:XML = <TextFlow xmlns='http://ns.adobe.com/textLayout/2008'>
            <format id="sub" baselineShift={DefaultValues.SUBSCRIPT_BASELINE_SHIFT} 
            	fontSize={DefaultValues.FONT_SIZE_SUBSCRIPT_TLF}/>
            <format id="sup" baselineShift={DefaultValues.SUPERSCRIPT_BASELINE_SHIFT}
            	fontSize={DefaultValues.FONT_SIZE_SUBSCRIPT_TLF}/>
            <p fontWeight="bold"><span>What are p</span>{kXML}{subAXML}<span> values?</span></p>
            <p/>
            <p><span>p</span>{kXML}{subAXML}<span> values 
            are characteristic constants for chemical compounds that 
            help chemists to describe and compare the reactivity of molecules. 
            The p</span>{kXML}{subAXML}<span> value reflects how 
            strongly a compound retains a proton. Strong acids 
            tend to release protons, whereas strong bases 
            tend to accept and retain protons.</span></p>
            <br/>
            <p fontWeight="bold"><span>How do p</span>{kXML}{subAXML}<span> values work?</span></p>
            <p/>
            <p>A <span>p</span>{kXML}{subAXML}<span> value
            is a convenient way to use an </span><span fontStyle="italic">acid dissociation 
            constant</span><span>. The acid dissociation constant, 
            or </span>{kXML}{subAXML}<span> value, is an equilibrium 
            constant for the dissociation of a proton from a molecule 
            in dilute aqueous solution: </span>
            <br/><br/><img source={formulaImagePath}/>
            <br/><br/><span>Since </span>{kXML}{subAXML}<span> values 
            can be very large or small numbers, it is easier to use a 
            logarithmic scale. The p</span>{kXML}{subAXML}<span> value 
            is the negative logarithm of the </span>{kXML}{subAXML}<span> value: </span>
            <br/><br/><span>p</span>{kXML}{subAXML}<span> 
            = -log</span><span format="sub">10</span>{kXML}{subAXML}<span></span>
            <br/><br/><span>A strong acid prefers to release a proton. 
            It will have a high </span>{kXML}{subAXML}<span> value 
            and a low p</span>{kXML}{subAXML}<span> value. Hydrochoric acid, 
            for example, has a </span>{kXML}{subAXML}<span> value of 10</span><span 
            format="sup">7</span><span> and a p</span>{kXML}{subAXML}<span> value of -7.</span>
            <br/><br/><span>A very weak acid prefers to retain a proton. 
            For example, ethane has a </span>{kXML}{subAXML}<span> value 
            of 10</span><span format="sup">-36</span><span> and 
            a p</span>{kXML}{subAXML}<span> value of 36.</span>
            </p>
            </TextFlow>;
            
            XML.ignoreWhitespace = true;
            
            return xml;
		}
	}
}